<!-- #include FILE=../res/cw_dbimp.txt -->
<%@ Import Namespace="System.Web.Security" %>

<html>

<head>
  <title>Careware - Impostazioni</title>
  <meta http-equiv="expires" content="0"/>
  <link rel="stylesheet" type="text/css" href="../res/default.css">
</head>

<!-- #include FILE=../res/cw_dbfunc.txt -->

<script runat="server">

void Page_Load(Object srcobj, EventArgs e) {
  if ( ! Context.User.Identity.IsAuthenticated ) Response.Redirect("../");
}

bool Change_Password( string pwdOld, string pwdNew ) {
	bool ok=false;
	string ip = Request.ServerVariables.Get("remote_addr");
	string usr = Context.User.Identity.Name;

	// apre la conn al database della sicurezza
	if ( ! dbfuncOpen( "careware_database" ) ) Msg.Text = "ERRORE in Configurazione del database!";

	try {
		IDbCommand cmd = conn.CreateCommand();
		cmd.CommandText = "select passwd from ts_ute where ds_ute='" + usr + "'";
		IDataReader reader = cmd.ExecuteReader();
		if ( ! reader.Read() ) { conn.Close(); return false; }
		string fld_passwd = (reader.IsDBNull(0) ? "" : reader.GetString(0));
		if (fld_passwd==pwdOld) { ok=true; } else { Err.Text= "Vecchia password non corretta per utente " + usr; }
		reader.Close();
		if (ok) {
			cmd.CommandText = "UPDATE ts_ute SET passwd=" + (pwdNew.Length==0 ? "null" : "'"+pwdNew+"'") + " WHERE ds_ute='" + usr + "'";
			cmd.ExecuteNonQuery();
		}
		cmd.CommandText = "select max(id_log) from ts_log";
		reader = cmd.ExecuteReader(); reader.Read();
		int next = ( reader.IsDBNull(0) ? 1 : reader.GetInt32(0)+1 );
		reader.Close();
		cmd.CommandText = "INSERT INTO ts_log (id_log, dt_log, usr, addr, app, type, code) VALUES (" + next + ",'" + DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "','" + usr + "','" + ip + "','ChgPwd',2," + (ok ? '1' : '0') + ")";
		cmd.ExecuteNonQuery();
	} catch (Exception ex) {
		ok=false;
		Err.Text = "Errore: " + ex.ToString();
	}
	// chiude la conn al database della sicurezza
	dbfuncClose();
	return ok;
}

void Ok_Click( Object sender, EventArgs e ) {
	if ( pwd_new.Value != pwd_new_bis.Value ) { Msg.Text="La nuova password non e' stata correttamente reinserita!"; return; }
	if ( Change_Password( pwd_old.Value, pwd_new.Value ) ) Msg.Text = "La password e' stata modificata!";
	else Msg.Text = "Attenzione: l'esecuzione dell'operazione non e' riuscita!";
}

</script>

<%
  string page="Impostazione password", menubar="", appmsg="";
%>

<!-- #include FILE=../res/cw_body_header.txt -->

<p>&nbsp;</p>

<div class='fun' align='center'>Modifica password per l'utente: <%= Context.User.Identity.Name %></div>

<form id='frm' runat='server'>
  <table align='center'>
    <tr>
      <td>Vecchia password</td>
      <td><input id='pwd_old' size='10' maxlength='100' type='password' value='' runat='server' /></td>
    </tr><tr>
      <td>Nuova password</td>
      <td><input id='pwd_new' size='10' maxlength='100' type='password' value='' runat='server'/></td>
    </tr><tr>
      <td>Reinserire nuova password</td>
      <td><input id='pwd_new_bis' size='10' maxlength='100' type='password' value='' runat='server'/></td>
    </tr><tr>
      <td><input type='submit' OnServerClick='Ok_Click' Value='Ok' runat='server'/></td>
    </tr>
  </table>
</form>

<asp:Label id="Err" ForeColor="red" runat=server align='center'/>

<!-- #include FILE=../res/cw_body_footer.txt -->

<script type='text/javascript'>
<!--
frm.pwd_old.focus();
//-->
</script>


</html>
